open Common;;
open Types;;
open Syntax;;

let inf u v =
 let u = repr u and v = repr v in
 match (u.data, v.data) with
   (Zero, _) -> zero_cell
 | (_, Zero) -> zero_cell
 | (One, _) -> v
 | (_, One) -> u
 | _ -> inf_cell (u, v);;

let (^^) f g = fun (x : ident) -> inf (f x) (g x);;

let fonc_of_var d m =
 fun x -> if List.mem x (fv_expr m) then d else one_cell;;
let appl_fonc p f m n =
 fun x -> if n = Ident x && not (List.mem x (fv_expr m)) then p
          else if not (List.mem x (fv_expr n)) then one_cell
          else inf p (f x);;
let zero = fun (x : ident) -> zero_cell;;
let one = fun (x : ident) -> one_cell;;
let zero_x (x : ident) =
 fun (y : ident) -> if x = y then zero_cell else one_cell;;
