open Common;;
open Types;;
open Set;;

let replace_up u v w =
 let l = snd (infs_sups w) in
 l := setq_add v (setq_minus !l [u]);;

let replace_down u v w =
 let l = fst (infs_sups w) in
 l := setq_add v (setq_minus !l [u]);;

let comp_connexe u =
 let l = ref [] in
 let rec loop u =
  let u = repr u in
  if not (List.memq u !l) then
   begin
    l := u::!l;
    let (l1,l2) = infs_sups u in
    List.iter loop !l1;
    List.iter loop !l2
   end
 in loop u; !l;;

let suppress_ineq u v =
 let (l1,l2) = infs_sups v in
 l1 := setq_minus !l1 [u];
 l2 := setq_minus !l2 [u];;

let suppress u =
 let foo u' v' =
  let l1 = snd (infs_sups u')
  and l2 = fst (infs_sups v') in
  l1 := setq_add v' !l1;
  l2 := setq_add u' !l2
 in let (l1,l2) = infs_sups u in
 List.iter (suppress_ineq u) !l1;
 List.iter (suppress_ineq u) !l2;
 List.iter (fun u' -> List.iter (foo u') !l2) !l1;;
