open Common;;
open Evaluator;;

let _ =
 let to_load = ref [] in
 Arg.parse [("-v", Arg.Set verbose_errors, "turn on verbose typing errors");
            ("-no_typing", Arg.Clear enable_typing, "turn off type checking")]
           (fun s -> to_load := s::!to_load)
           "Usage: mlobj <options> [file.mlobj] ...\n  file.mlobj: file(s) to be loaded when starting";
 print_string "       MlObj v0.07 : ML + Objects + Degrees + Mixins + Recursive types + Abstract machine\n\n";
 List.iter interpret_file (List.rev !to_load);
 if !to_load <> [] then print_newline ();
 try
  interpret_channel true stdin
 with
  Lexer.Eof -> ();;
