open Types;;

let set_empty = [];;
let set_add x l = if List.mem x l then l else x::l;;
let set_union l = List.fold_right set_add l;;
let set_minus l1 l2 = List.filter (fun x -> not (List.mem x l2)) l1;;

let setq_empty = [];;
let setq_add x l = if List.memq x l then l else x::l;;
let setq_union l = List.fold_right setq_add l;;
let setq_minus l1 l2 = List.filter (fun x -> not (List.memq x l2)) l1;;

let setq2_empty = [];;
let setq2_add (x,y) l =
 let rec loop = function
    [] -> [(x,y)]
  | ((x',y')::r) -> if x == x' && y == y'
                    then (x',y')::r
		    else (x',y')::(loop r)
 in loop l;;
let setq2_union l = List.fold_right setq2_add l;;

let poly_empty =
 { tvar = setq_empty; rvar = setq_empty; dvar = setq_empty };;

let poly_union p q =
 { tvar = setq_union p.tvar q.tvar;
   rvar = setq_union p.rvar q.rvar;
   dvar = setq_union p.dvar q.dvar };;

let poly_minus p q =
 { tvar = setq_minus p.tvar q.tvar;
   rvar = setq_minus p.rvar q.rvar;
   dvar = setq_minus p.dvar q.dvar };;
